# _/_/_/_/_/_/_/_/ WinAX206.py _/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
#
# program to access the DPF AppoTech_AX206 - 2,4" - 320 x 240 Pixel 
# on windows 7 via USB ... by pure python code
# LOU CYFER 2011-01
#

import usb.core
import usb.util
import time
from time import gmtime, strftime
import random
import sys

import signal
import os
import thread
import threading
import pythoncom

DEBUG = False

	

# ---  dev.reset()
# ---  time.sleep(0.5)
# ---  dev = usb.core.find(idVendor=idV, idProduct=idP)

# ---  dev.set_configuration()


def print_hex_list(buf0):
	s0 = '  idx = '
	for i0 in range(len(buf0)):	s0 += '%02d' % i0 +','
	print s0
	s0 = '  hex = '
	for i0 in range(len(buf0)):	s0 += '%02x' % buf0[i0] +','
	print s0,
	
	print '('+str(len(buf0))+')'



# LOW LEVEL FIRMWARE FUNCTIONS _/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/

g_buf = [
	0x55, 0x53, 0x42, 0x43, 	# dCBWSignature	
	0xaf, 0x00, 0x00, 0x00, 	# dCBWTag
	0x00, 0x80, 0x00, 0x00, 	# dCBWLength
	0x00, 				# bmCBWFlags: 0x80: data in (dev to host), 0x00: Data out
	0x00, 				# bCBWLUN
	0x10, 				# bCBWCBLength

	0xcd, 0x00, 0x00, 0x00,	# SCSI cmd
	0x00, 0x06, 0x11, 0xf8,	# SCSI cmd
	0x70, 0x00, 0x40, 0x00,	# SCSI cmd
	0x00, 0x00, 0x00, 0x00,	# SCSI cmd
]

def emulate_scsi(dev0, cmd, cmd_type, data):

	g_buf[14] = len(cmd)

	for i0 in range(len(cmd)):
		g_buf[15+i0] = cmd[i0]

	g_buf[8] = 	(len(data)) 		& 0xFF
	g_buf[9] = 	(len(data) >> 8 )	& 0xFF
	g_buf[10] = 	(len(data) >> 16 )	& 0xFF
	g_buf[11] = 	(len(data) >> 24 )	& 0xFF

	if DEBUG: print 'len(cmd)    = ' + str( len(cmd) )
	if DEBUG: print 'len(data)   = ' + str( len(data) )

	if DEBUG: print 'write-part-1:'
	if DEBUG: print_hex_list(g_buf[0:15])
	if DEBUG: print 'write-part-2:'
	if DEBUG: print_hex_list(g_buf[15:31])

	if DEBUG: print( 'dev.write '+cmd_type+'...' )
	w0 = dev.write(1, g_buf, 0,10000)
	
	if cmd_type=='CMD_AND_DATA':
		if DEBUG: print( 'dev.write '+cmd_type+' (data block)....' )
		w1 = dev.write(1, data, 0, 10000);


	r0 = dev.read(0x81, 100, 0);
	if DEBUG: print 'len(read)    = ' + str( len(r0) )

	if DEBUG: print 'read-part:'
	if DEBUG: print_hex_list(r0)

	if DEBUG: print
	




def WH(w0):	return  (w0 >> 8) & 0xFF
def WL(w0):	return  w0 & 0xFF
def WHm(w0):	return  ((w0-1) >> 8) & 0xFF
def WLm(w0):	return  (w0-1) & 0xFF




def dpf_screen_blit(buf0,rect):
	
	cmd0 = [ 	0xcd, 0, 0, 0, 0, 6, \
			0x12, # USBCMD_BLIT \
			WL(rect[0]),  WH(rect[0]),  WL(rect[1]),  WH(rect[1]), \
			WLm(rect[2]), WHm(rect[2]), WLm(rect[3]), WHm(rect[3]), \
			0 ]
			
	emulate_scsi(-1, cmd0 , 'CMD_AND_DATA',	buf0)





def dpf_fillrect(rect):
	
	cmd0 = [ 	0xcd, 0, 0, 0, 0, 6, \
			0x11, # USBCMD_FILLRECT \
			WL(rect[0]),  WH(rect[0]),  WL(rect[1]),  WH(rect[1]), \
			WLm(rect[2]), WHm(rect[2]), WLm(rect[3]), WHm(rect[3]), \
			0 ]
			
	emulate_scsi(-1, cmd0 , 'CMD_ONLY', [])



def dpf_setcol(rgb):
	
	pro0 =   0x0002 # PROPERTY_FGCOLOR
	
	cmd0 = [ 	0xcd, 0, 0, 0, 0, 6, \
			0x01, # USBCMD_SETPROPERTY  \
			WL(pro0),  WH(pro0), \
			WL(rgb),   WH(rgb),  \
			0,0, 0,0, 0 ]
			
	emulate_scsi(-1, cmd0 , 'CMD_ONLY', [])





def dpf_setproperty( token, value ):
	
	cmd0 = [ 	0xcd, 0, 0, 0, 0, 6, \
			0x01, # USBCMD_SETPROPERTY  \
			WL(token),  WH(token), \
			WL(value),   WH(value),  \
			0,0, 0,0, 0 ]
			
	emulate_scsi(-1, cmd0 , 'CMD_ONLY', [])



def RAW565(img0):

	raw1 = img0.tostring()
	raw2 = []

	i1=0
	for i2 in range (img0.size[0]*img0.size[1]):
	
		RR = ord( raw1[i1 + 0 ] ) >> 3
		GG = ord( raw1[i1 + 1 ] ) >> 2
		BB = ord( raw1[i1 + 2 ] ) >> 3
	
		RGB = RR << 11 |  GG<<5 | BB
	
		raw2 += [ RGB >> 8 ]
		raw2 += [ RGB & 0xFF ]
		i1 += 3

	if DEBUG: print 'len(raw1) '+ str(len(raw1)) + ' => len(raw2) = '+ str(len(raw2))
	
	return(raw2)




# THREADING _/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/

class Operation(threading._Timer):
    def __init__(self, *args, **kwargs):
        threading._Timer.__init__(self, *args, **kwargs)
        self.setDaemon(True)

    def run(self):
        while True:
            self.finished.clear()
            self.finished.wait(self.interval)
            if not self.finished.isSet():
                self.function(*self.args, **self.kwargs)
            else:
                return
            self.finished.set()


class Manager(object):

    ops = []

    def add_operation(self, operation, interval, args=[], kwargs={}):
        op = Operation(interval, operation, args, kwargs)
        self.ops.append(op)
        return thread.start_new_thread(op.run, ())

    def stop(self):
        for op in self.ops:
            op.cancel()
        self._event.set()



# HIGH LEVEL DPF FUNCTIONS _/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/

import Image
import ImageGrab


bytes_per_pixel = 2		# => 320*240*2 = 153600 bytes
xwid = 320
ywid = 240

xp = 8
yp = 8

xc = 16
yc = 6

font_gridy = 4

F0 = Image.open('fonts_n_icons\8x8s.png').convert('RGB')
F0_raw = RAW565(F0)

dpf_font_idx  = 0
dpf_font_off = [ 	0,                 #0 \
				F0.size[0]*xp*6,   #1 \
				F0.size[0]*xp*12,  #2 \
				F0.size[0]*xp*18,  #3 \
				F0.size[0]*xp*22,  #4 \
				F0.size[0]*xp*28,  #5 \
				F0.size[0]*xp*34,  #6 \
				F0.size[0]*xp*40,  #7 \
				F0.size[0]*xp*44,  #8 \
				F0.size[0]*xp*50,  #9 \
				F0.size[0]*xp*54,  #10 \
				F0.size[0]*xp*58,  #11 \
				
				xc*xp+64 +0,                 #12 \
				xc*xp+64 + F0.size[0]*xp*4,  #13 \
				xc*xp+64 + F0.size[0]*xp*8,  #14 \
				xc*xp+64 + F0.size[0]*xp*12, #15 \
				xc*xp+64 + F0.size[0]*xp*16, #16 \
				xc*xp+64 + F0.size[0]*xp*20, #17 \
				xc*xp+64 + F0.size[0]*xp*24, #18 \
				xc*xp+64 + F0.size[0]*xp*30, #19 \
				xc*xp+64 + F0.size[0]*xp*34, #20 \
				xc*xp+64 + F0.size[0]*xp*38, #21 \
				xc*xp+64 + F0.size[0]*xp*42, #22 \
				xc*xp+64 + F0.size[0]*xp*46, #23 \
				xc*xp+64 + F0.size[0]*xp*50, #24 \
				xc*xp+64 + F0.size[0]*xp*58  #25 \
				 ]




def dpf_print(x,y,s0, dpf_font_idx=1):

	global font_gridy

	xpos = xp*x
	ypos = (yp+font_gridy)*y

	buf0=[]

	for yi in range(yp):

		for c0 in s0:		
		
			c_idx = ord(c0)-ord(' ') 
			c_yo = int( c_idx / xc )
			c_xo = c_idx - c_yo*xc

			#print str( c_xo )
		
			for xi in range(xp):

				font_idx  = F0.size[0] *yi + xi + xp*c_xo + F0.size[0] * yp*c_yo
				
				font_idx += dpf_font_off[dpf_font_idx]
				
	
				buf0 += [ F0_raw[ ( font_idx )*2    ] ]	
				buf0 += [ F0_raw[ ( font_idx )*2 +1 ] ]
				
	dpf_screen_blit(buf0,[xpos,ypos,xpos+xp*len(s0),ypos+yp])



def dpf_cls(rgb):
	buf0=[]
	for i0 in range(xwid*ywid*2): buf0 += [rgb]
	dpf_screen_blit(buf0,[0,0,xwid,ywid])

def dpf_flash():
	for bright in range(0x07):
		dpf_setproperty(0x01,bright)	# PROPERTY_BRIGHTNESS
		time.sleep(0.05)



# VA FUNCTIONS _/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/

T0 = 0
T1 = 0
Tdiff = 0

def TIM_top():
	global T0,T1
	T0 = time.clock()
	return( 'TIM_top()' )

def TIM_bot():
	global T0,T1
	T1 = time.clock()
	Tdiff = T1-T0	
	return( 'TIM_bot() = %8.6f [sec] ' % (Tdiff) )





def ASCII_BAR_PROG(val0,max0,chars0, bar_char='X', blank_char='-'):

	tmp0 =''
	bar0 = int( float(val0+(max0/chars0-1)) / float(max0) * float(chars0) )
	for i0 in range(        bar0):	tmp0 += bar_char
	for i0 in range( chars0-bar0):	tmp0 += blank_char
	tmp0 += ''
			
	return(tmp0)
	

ASCII_PRINT_str = ''

def ASCII_PRINT(str0):
	global ASCII_PRINT_str
	ASCII_PRINT_str= str0
	sys.stdout.write(ASCII_PRINT_str)

def ASCII_DEL_LAST():
	global ASCII_PRINT_str
	sys.stdout.write('\b'*len(ASCII_PRINT_str))
	sys.stdout.write( ' '*len(ASCII_PRINT_str))
	sys.stdout.write('\b'*len(ASCII_PRINT_str))
	
	

def ASCII_ART_BAR(sec0,typ0,bl):
	
	for i0 in range(0,bl+1):

		if typ0=='[sec]': form0 = '[sec] %4.1f ' % (float(i0)/bl*sec0)
		
		sys.stdout.write(form0)

		sys.stdout.write(i0*chr(219) + (bl-i0)*chr(254))
		sys.stdout.flush()
		time.sleep(float(sec0)/bl)
	
		sys.stdout.write(len(form0)*'\b' + bl*'\b')
		sys.stdout.flush()
	
	sys.stdout.write(len(form0)* ' ' + bl* ' ')
	sys.stdout.write(len(form0)*'\b' + bl*'\b')
	sys.stdout.flush()
	
	
dns_file		= "check_dns.py.dns.log"

def read_dns_table():

	global dns_file

	ret0 = open(dns_file, 'r').read()

	return(eval(ret0))
	



def signal_handler(signal, frame):
    print '\nCtrl+C => TERMINATE... PLS WAIT\n'
    APP_EXIT = True
    time.sleep(T_SCAN)
    sys.exit(0)
  



# MAIN _/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/

os.system('cls && mode 100,30 && color 1F')
	
PSCRIPT = os.path.basename(__file__)

B0 = chr(254)
print B0*80
print B0+ ' '+PSCRIPT+ ': USB DPF CONTROL by L.CYFER 2012'
print B0*80

APP_EXIT = False
T_SCAN = 3

idV = 0x1908
idP = 0x0102

dev = None

while dev==None:

	print 'seek USB device by idV= '+ hex(idV) + ' & idP= '+ hex(idP)

	dev = usb.core.find(idVendor=idV, idProduct=idP)

	if dev==None:
		print 'NO DEVICE FOUND.'
		print 'sleep ...',
		ASCII_ART_BAR(3,'[sec]',30)
	else:
		str0 = ''
		print 'FOUND: str(dev) = ' + str(dev)
		for i0 in range(1,5): str0 += usb.util.get_string(dev, 100, i0)+', '
		print 'FOUND: args     = ' + str0  

	
dev.set_configuration()



# PRINT SOME DEMO SCREENS

dpf_cls(0x00)

font_gridy = 0

TIM_top()

for i0 in range(len(dpf_font_off)):
	dpf_font_idx = i0
	dpf_print(1,1+i0,'%2d ABCDEFGHIJK pqrstuvwx 0123456789' % i0, i0 )

dpf_font_idx = 0
dpf_print(1,1+i0+2, TIM_bot() )

ASCII_PRINT('NEXT demo in ')
ASCII_ART_BAR(T_SCAN,'[sec]',30)
ASCII_DEL_LAST()




# TEST PIC - COLOR BARS
# bits: 5xR 6xG 5xB = RRRRR GGGGGG BBBBB => 0..1F, 0..3F, 0..1f

buf0=[]
for y0 in range(ywid):
	for x0 in range(xwid):
		
		luma = x0 & 0x3f
		
		if y0>=0:		rgb = luma << 11
		if y0>=80:	rgb = luma << 5
		if y0>=160:	rgb = luma
		
		buf0 += [ (rgb>>8) & 0xff ]
		buf0 += [ (rgb>>0) & 0xff ]

dpf_screen_blit(buf0,[0,0,xwid,ywid])

ASCII_PRINT('NEXT demo in ')
ASCII_ART_BAR(T_SCAN,'[sec]',30)
ASCII_DEL_LAST()



# sendd some more pics / desktop snapshot _/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/



i0 = Image.open('bitch.jpg')
#i1 = i0.resize((xwid,ywid), Image.ANTIALIAS)

raw2 = RAW565(i0)

dpf_screen_blit(raw2,[0,0,xwid,ywid])

ASCII_PRINT('NEXT demo in ')
ASCII_ART_BAR(T_SCAN,'[sec]',30)
ASCII_DEL_LAST()



bx=70
by=70

i0 = ImageGrab.grab()
#i1 = i0.crop((0,0,bx,by))
i0 = i0.resize((xwid,ywid), Image.ANTIALIAS)

raw2 = RAW565(i0)

dpf_screen_blit(raw2,[0,0,xwid,ywid])

ASCII_PRINT('NEXT demo in ')
ASCII_ART_BAR(T_SCAN,'[sec]',30)
ASCII_DEL_LAST()





def scan():
	
	global dpf_font_idx

	
	pythoncom.CoInitialize ()
	
	TIM_top()

	DNS = read_dns_table()
	
	time0 	= time.localtime()
	NOW_DATE	= '2012-01-28'		
	NOW_TIME	= strftime('%H-%M-%S', time0)

	dpf_font_idx = 1

	dpf_print( 1,1+ 0, '%16s' % 'NOW' +' = '+ NOW_DATE +' '+NOW_TIME )
	
	dpf_print( 1,1+ 2, '%16s' % DNS[0][0] +' =   '+ '%-16s' % DNS[0][1] )
	dpf_print(20,1+ 2, ['A','B'][DNS[0][1]!='n/a'], 2 ) 

	for i0 in range(1,len(DNS)):
		dpf_print( 1,1+ 2+i0, '%16s' % DNS[i0][0] +' =   '+ '%-16s' % DNS[i0][1] )
		dpf_print(20,1+ 2+i0, ['A','B'][DNS[i0][1]!='OFFLINE'], 2 ) 
	
	
	
	file_log = 'LOG_scan_sys\\scan_sys.'+NOW_DATE+'.log'

	#dpf_print(1,1+03, file_log ) 

	if os.path.exists(file_log):
		
		file_log_h = open(file_log, "r")
		
		lines0 = file_log_h.readlines()
		file_log_h.close()
		
		la0 = lines0[-1].split(' ')

		dpf_print( 1, 1+ 7, la0[ 2]+'  '+la0[ 3]+' '+la0[ 4], 1 )
		dpf_print(16, 1+ 7, ASCII_BAR_PROG(int(la0[ 3]),100,22,'A','-'), 2 ) 
		
		dpf_print( 1, 1+ 8, la0[12]+'  '+la0[13]+' '+la0[14] )
		dpf_print(16, 1+ 8, ASCII_BAR_PROG(int(la0[13]),100,22,'B','-'), 2 ) 
		
		dpf_print( 1, 1+ 9, la0[15]+' '+la0[20]+' '+la0[21] )
		dpf_print(16, 1+ 9, ASCII_BAR_PROG(int(float(la0[20])),100,22,'C','-'), 2 ) 
		
		dpf_print( 1, 1+10, la0[22]+' '+la0[27]+' '+la0[28] )
		dpf_print(16, 1+10, ASCII_BAR_PROG(int(float(la0[27])),100,22,'D','-'), 2 ) 
	else:
		dpf_print( 1, 1+ 7, 'LOG FILE NON EXISTING  !!!' ) 


	file_log = 'LOG_scan_serial\\scan_serial.'+NOW_DATE+'.log'

	if os.path.exists(file_log):
		
		file_log_h = open(file_log, "r")
		
		lines0 = file_log_h.readlines()
		file_log_h.close()
		
		la0 = lines0[-1].split(' ')

		dpf_print( 1, 1+12, '1:    2:    3:    4:    5:    6:  ', 1 )
		dpf_print( 1, 1+13, 'ARdr  ARhk  AR2   HZ    SZ    WZ', 1 )
		dpf_print( 1, 1+14, la0[ 3]+' '+la0[ 5]+' '+la0[ 7]+' '+la0[ 9]+' '+la0[11]+' '+la0[13], 1 )
		dpf_print( 1, 1+15, la0[19]+' '+la0[21]+' '+la0[23]+' '+la0[25]+' '+la0[27]+' '+la0[29], 1 )
	else:
		dpf_print( 1, 1+12, 'LOG FILE NON EXISTING !!!' ) 



	dpf_print(1,1+18, TIM_bot() )


	pythoncom.CoUninitialize ()


 
signal.signal(signal.SIGINT, signal_handler)







# CYCLIC UPDATE OF DPF by THREAD _/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/

timer = Manager()

T1 = timer.add_operation(scan, T_SCAN)
  
dpf_cls(0x00)

font_gridy = 4

while APP_EXIT!=True:

	ASCII_PRINT( 'UPDATE DPF in' )
	ASCII_ART_BAR(T_SCAN,'[sec]',30)
	ASCII_DEL_LAST()











